// GENERATED CODE - DO NOT MODIFY BY HAND

part of example.basic_auth.server;

// **************************************************************************
// Generator: ApiGenerator
// Target: class LibraryApi
// **************************************************************************

class JaguarLibraryApi implements RequestHandler {
  static const List<RouteBase> routes = const <RouteBase>[];

  final LibraryApi _internal;
  final JaguarAuthRoutes _authInternal;
  final JaguarStudentRoutes _studentInternal;

  factory JaguarLibraryApi() {
    final instance = new LibraryApi();
    return new JaguarLibraryApi.from(instance);
  }
  JaguarLibraryApi.from(this._internal)
      : _authInternal = new JaguarAuthRoutes.from(_internal.auth),
        _studentInternal = new JaguarStudentRoutes.from(_internal.student);

  Future<Response> handleRequest(Request request, {String prefix: ''}) async {
    prefix += '/api';
    {
      Response response =
          await _authInternal.handleRequest(request, prefix: prefix);
      if (response is Response) {
        return response;
      }
    }

    {
      Response response =
          await _studentInternal.handleRequest(request, prefix: prefix);
      if (response is Response) {
        return response;
      }
    }

    return null;
  }
}

// **************************************************************************
// Generator: RouteGroupGenerator
// Target: class AuthRoutes
// **************************************************************************

class JaguarAuthRoutes implements RequestHandler {
  static const List<RouteBase> routes = const <RouteBase>[
    const Post(path: '/login'),
    const Post(path: '/logout')
  ];

  final AuthRoutes _internal;

  factory JaguarAuthRoutes() {
    final instance = new AuthRoutes();
    return new JaguarAuthRoutes.from(instance);
  }
  JaguarAuthRoutes.from(this._internal);

  Future<Response> handleRequest(Request request, {String prefix: ''}) async {
    PathParams pathParams = new PathParams();
    bool match = false;

//Handler for login
    match =
        routes[0].match(request.uri.path, request.method, prefix, pathParams);
    if (match) {
      Response<dynamic> rRouteResponse0 = new Response(null);
      SessionInterceptor iSessionInterceptor;
      UsernamePasswordAuth iUsernamePasswordAuth;
      try {
        iSessionInterceptor = new WrapSessionInterceptor(
          makeParams: const <Symbol, MakeParam>{
            #sessionManager: const MakeParamFromMethod(#sessionManager)
          },
          sessionManager: _internal.sessionManager(),
        )
            .createInterceptor();
        SessionManager rSessionInterceptor = await iSessionInterceptor.pre(
          request,
        );
        iUsernamePasswordAuth = new WrapUsernamePasswordAuth(
          modelManager: kModelManager,
        )
            .createInterceptor();
        await iUsernamePasswordAuth.pre(
          request,
          rSessionInterceptor,
        );
        _internal.login(
          null,
        );
        Response<dynamic> rRouteResponse1 = await iSessionInterceptor.post(
          request,
          rRouteResponse0,
        );
        return rRouteResponse1;
      } catch (e) {
        await iUsernamePasswordAuth?.onException();
        await iSessionInterceptor?.onException();
        rethrow;
      }
    }

//Handler for logout
    match =
        routes[1].match(request.uri.path, request.method, prefix, pathParams);
    if (match) {
      Response<dynamic> rRouteResponse0 = new Response(null);
      SessionInterceptor iSessionInterceptor;
      try {
        iSessionInterceptor = new WrapSessionInterceptor(
          makeParams: const <Symbol, MakeParam>{
            #sessionManager: const MakeParamFromMethod(#sessionManager)
          },
          sessionManager: _internal.sessionManager(),
        )
            .createInterceptor();
        await iSessionInterceptor.pre(
          request,
        );
        _internal.logout();
        Response<dynamic> rRouteResponse1 = await iSessionInterceptor.post(
          request,
          rRouteResponse0,
        );
        return rRouteResponse1;
      } catch (e) {
        await iSessionInterceptor?.onException();
        rethrow;
      }
    }

    return null;
  }
}

// **************************************************************************
// Generator: RouteGroupGenerator
// Target: class StudentRoutes
// **************************************************************************

class JaguarStudentRoutes implements RequestHandler {
  static const List<RouteBase> routes = const <RouteBase>[
    const Get(path: '/all'),
    const Get(path: '/:id', headers: const {'sample-header': 'sample-value'})
  ];

  final StudentRoutes _internal;

  factory JaguarStudentRoutes() {
    final instance = new StudentRoutes();
    return new JaguarStudentRoutes.from(instance);
  }
  JaguarStudentRoutes.from(this._internal);

  Future<Response> handleRequest(Request request, {String prefix: ''}) async {
    prefix += '/book';
    PathParams pathParams = new PathParams();
    bool match = false;

//Handler for getAllBooks
    match =
        routes[0].match(request.uri.path, request.method, prefix, pathParams);
    if (match) {
      Response<String> rRouteResponse0 = new Response(null);
      SessionInterceptor iSessionInterceptor;
      UserAuthoriser iUserAuthoriser;
      try {
        iSessionInterceptor = new WrapSessionInterceptor(
          makeParams: const <Symbol, MakeParam>{
            #sessionManager: const MakeParamFromMethod(#sessionManager)
          },
          sessionManager: _internal.sessionManager(),
        )
            .createInterceptor();
        SessionManager rSessionInterceptor = await iSessionInterceptor.pre(
          request,
        );
        iUserAuthoriser = new WrapUserAuthoriser(
          modelManager: kModelManager,
        )
            .createInterceptor();
        await iUserAuthoriser.pre(
          request,
          rSessionInterceptor,
        );
        rRouteResponse0 = _internal.getAllBooks();
        Response<dynamic> rRouteResponse1 = await iUserAuthoriser.post(
          request,
          rRouteResponse0,
          rSessionInterceptor,
        );
        Response<dynamic> rRouteResponse2 = await iSessionInterceptor.post(
          request,
          rRouteResponse1,
        );
        return rRouteResponse2;
      } catch (e) {
        await iUserAuthoriser?.onException();
        await iSessionInterceptor?.onException();
        rethrow;
      }
    }

//Handler for getBook
    match =
        routes[1].match(request.uri.path, request.method, prefix, pathParams);
    if (match) {
      Response<String> rRouteResponse0 = new Response(null);
      SessionInterceptor iSessionInterceptor;
      UserAuthoriser iUserAuthoriser;
      try {
        iSessionInterceptor = new WrapSessionInterceptor(
          makeParams: const <Symbol, MakeParam>{
            #sessionManager: const MakeParamFromMethod(#sessionManager)
          },
          sessionManager: _internal.sessionManager(),
        )
            .createInterceptor();
        SessionManager rSessionInterceptor = await iSessionInterceptor.pre(
          request,
        );
        iUserAuthoriser = new WrapUserAuthoriser(
          modelManager: kModelManager,
        )
            .createInterceptor();
        await iUserAuthoriser.pre(
          request,
          rSessionInterceptor,
        );
        rRouteResponse0.statusCode = 200;
        rRouteResponse0.headers['sample-header'] = 'sample-value';
        rRouteResponse0.headers
            .set('content-type', 'text/plain; charset=utf-8');
        rRouteResponse0.value = _internal.getBook(
          (pathParams.getField('id')),
        );
        Response<dynamic> rRouteResponse1 = await iUserAuthoriser.post(
          request,
          rRouteResponse0,
          rSessionInterceptor,
        );
        Response<dynamic> rRouteResponse2 = await iSessionInterceptor.post(
          request,
          rRouteResponse1,
        );
        return rRouteResponse2;
      } catch (e) {
        await iUserAuthoriser?.onException();
        await iSessionInterceptor?.onException();
        rethrow;
      }
    }

    return null;
  }
}
